#include <stdio.h>
#include <time.h>

typedef struct
 {
 char Name[200];
 double offset;
 double faktor;
 int anzeige;
 } satz;


FILE *outfile;
double *werte;
satz *feld;
int spalten,Minzeit=0;

int Ausg(time_t t)
 {
  int a;
  struct tm *pTime;
  
  pTime=localtime(&t);
  fprintf(outfile,"%02d.%02d.%04d;%02d:%02d:%02d",pTime->tm_mday,
                                               pTime->tm_mon+1,
                                               pTime->tm_year+1900,
                                               pTime->tm_hour,
                                               pTime->tm_min,
                                               pTime->tm_sec);
  
  for(a=1;a<spalten;a++)
   {
    if(feld[a].anzeige) fprintf(outfile,";%lf",werte[a]);
   }
   
 fprintf(outfile,"\n");
 return 0;
 }




int main(int argc,char **argv)
 {
 int Separator=',',
      MinInterval=0,
      a,c,umgesetzt,monat,jahr;
 double wert;
 FILE *config,*infile;
 char st1[2000],*cp,*cp1,*cp2;
 time_t altzeit,aktzeit;
 struct tm t;
 
 if(argc<2)
  {
  printf("Benutzung:\nconv <rohdatei> [configdatei] [zieldatei]\n");
  return -1;
  }
 
 strcpy(st1,"config.txt");
 if(argc>2) strcpy(st1,argv[2]);
 /*Konfigurationsdatei ffnen*/
 config=fopen(st1,"r");
 if(!config)
  {
  printf("Configdatei %s nicht gefunden!\n",st1);
  return -1;
  }

 /* Erfassen, wie viele Zeilen Musterzeilen enthalen (mindestens 3 Semikolon) */

 /* erste Zeile lesen */
 spalten=0;
 while(!feof(config))
  {
  /* nchste Zeile lesen */
  memset(st1,0,1990);
  fgets(st1,1990,config);
  cp=st1;
  a=0;
  while(cp=strchr(cp+1,';')) a++;
  if (a>=3) spalten++;
  }
 printf ("%d Spalten\n",spalten);
 rewind(config);
 

 /*Speicher reservieren*/
 feld=calloc(spalten,sizeof(satz));
 werte=calloc(spalten,sizeof(double));
 cp=st1;

 /*Jetzt die Config richtig einlesen*/
 a=0;
 while (!feof(config))
  {
   memset(st1,0,20);
   fgets(st1,1990,config);
   /* CR durch Semikolon ersetzen */
   if(cp=strchr(st1,'\n')) *cp=';';
   
   if(cp=strchr(st1,'='))
    {
     /* Parameterzeile */
     *cp=0;
     cp++;
     cp1=st1;
     if(*cp1=='"') cp1++;
     if(!strcmp(cp1,"Separator"))
      {
      sscanf(cp,"%d;",&Separator);
      }
     if(!strcmp(cp1,"Minzeit"))
      {
      sscanf(cp,"%d;",&Minzeit);
      }
    }
   else
    { 
    c=0;
    cp=st1;
    while(cp=strchr(cp+1,';')) c++;
    if (c>=3)
    {
     /* Musterzeile */
    cp1=strchr(st1,';');
    if(cp1) *cp1=0;
    cp1++;
    cp=st1;
    if(*cp=='"')
     {
     cp++;
     if(cp2=strchr(cp,'"')) *cp2=0;
     }
    strcpy(feld[a].Name,cp);
    cp=cp1;
   
    /* Kommas durch Punkte ersetzen*/
    while(cp1=strchr(cp1,',')) *cp1='.';

    cp1=strchr(cp,';');
    if(cp1) *cp1=0;
    cp1++;
    sscanf(cp,"%lf",&feld[a].offset);
    cp=cp1;
   
    cp1=strchr(cp,';');
    if(cp1) *cp1=0;
    cp1++;
    sscanf(cp,"%lf",&feld[a].faktor);
    cp=cp1;
   
    cp1=strchr(cp,';');
    if(cp1) *cp1=0;
    cp1++;
    sscanf(cp,"%d",&feld[a].anzeige);
    cp=cp1;
    
    a++;
    }
    }
  } 
 fclose(config);
 printf(" %d gelesene Spalten\n",a);
 spalten=a;	/* so viele haben wir wirklich */
 
 /* Tabelle auf Bildschirm */
 for(a=1;a<spalten;a++)
  {
  printf("%4d %30s %15lf %15lf %3d\n",a,feld[a].Name,feld[a].offset,feld[a].faktor,
                                       feld[a].anzeige);
  }

 printf("Beginne mit konvertieren...\n");
 
 /* Versuchen Arbeitsdatei zu ffnen */
 infile=fopen(argv[1],"r");
 if(!infile)
  {
  printf("Eingabedatei %s konnte nicht geffnet werden!\n",argv[1]);
  return -1;
  }
 
 /* Ausgabedatei ffnen */
 strcpy(st1,"temp.csv");
 if(argc>3) strcpy(st1,argv[3]);
 outfile=fopen(st1,"w");

 printf("Kopfzeile schreiben...\n");

 /*Kopfzeile schreiben*/
 fprintf(outfile,"Datum;Zeit");
 for(a=1;a<spalten;a++)
  {
  printf("Zeile %d\n",a);
  if(feld[a].anzeige) fprintf(outfile,";%s",feld[a].Name);
  }
 fprintf(outfile,"\n");
 
 /* Werte konvertieren */
 
 while(!feof(infile))
  {
   memset(st1,0,20);
   fgets(st1,1990,infile);
   if(!feof(infile))
   {
   /* Wagenrcklauf durch Separator ersetzen */
   if (cp=strchr(st1,'\n')) *cp=Separator;
   
   /* Separatoren zhlen */
   a=0;
   cp=st1;
   while (cp=strchr(cp+1,Separator)) a++;
   if(a>=spalten+2)
 
   {
   /* Datensatz fr gltig befunden */
   cp=strchr(st1,Separator);
   *cp=0;
   cp++;
   memset(&t,0,sizeof(t));   

   /* Datum einlesen */

   sscanf(st1,"%d.%d.%d",&t.tm_mday,&monat,&jahr);
   
   cp1=strchr(cp,Separator);
   if(!cp1)
    {
    printf("Formatfehler");
    return -1;
    }
   *cp1=0;
   cp1++;
   
   /* Uhrzeit einlesen */
   
   sscanf(cp,"%d:%d:%d",&t.tm_hour,&t.tm_min,&t.tm_sec);

   t.tm_mon=monat-1;
   t.tm_year=jahr-1900;
   aktzeit=mktime(&t);   
   
   if(Minzeit)
    {
    if(aktzeit>(altzeit+Minzeit))
     {
     /* Fge noch eine Zeile mit alten Werten ein */
     Ausg(aktzeit-Minzeit);
     }
    }
      
   /* Werte bertragen */
   umgesetzt=0;
   for(a=1;a<spalten;a++)
    {
    cp=strchr(cp1,Separator);
    if(!cp)
     {
     printf("Formatfehler\n");
     return -1;
     }
    *cp=0;
    cp++;
    sscanf(cp1,"%lf",&werte[a]);

    /* Jetzt die Berechnungen */
    werte[a]=feld[a].faktor*(werte[a]-feld[a].offset);
    
    umgesetzt++;
    cp1=cp;
    }
    Ausg(aktzeit);
    altzeit=aktzeit;
    }
    }
  }

 fclose(outfile);
 fclose(infile);
 free(feld);
 free(werte);
 return 0;
 }
